/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED BY BPFTOOL! */
#ifndef __BENCH_UPROBE_BPF_SKEL_H__
#define __BENCH_UPROBE_BPF_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

struct bench_uprobe_bpf {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *bss;
		struct bpf_map *rodata_str1_1;
	} maps;
	struct {
		struct bpf_program *empty;
		struct bpf_program *trace_printk;
	} progs;
	struct {
		struct bpf_link *empty;
		struct bpf_link *trace_printk;
	} links;
	struct bench_uprobe_bpf__bss {
		unsigned int nr_uprobes;
	} *bss;

#ifdef __cplusplus
	static inline struct bench_uprobe_bpf *open(const struct bpf_object_open_opts *opts = nullptr);
	static inline struct bench_uprobe_bpf *open_and_load();
	static inline int load(struct bench_uprobe_bpf *skel);
	static inline int attach(struct bench_uprobe_bpf *skel);
	static inline void detach(struct bench_uprobe_bpf *skel);
	static inline void destroy(struct bench_uprobe_bpf *skel);
	static inline const void *elf_bytes(size_t *sz);
#endif /* __cplusplus */
};

static void
bench_uprobe_bpf__destroy(struct bench_uprobe_bpf *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
bench_uprobe_bpf__create_skeleton(struct bench_uprobe_bpf *obj);

static inline struct bench_uprobe_bpf *
bench_uprobe_bpf__open_opts(const struct bpf_object_open_opts *opts)
{
	struct bench_uprobe_bpf *obj;
	int err;

	obj = (struct bench_uprobe_bpf *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = bench_uprobe_bpf__create_skeleton(obj);
	if (err)
		goto err_out;

	err = bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	bench_uprobe_bpf__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct bench_uprobe_bpf *
bench_uprobe_bpf__open(void)
{
	return bench_uprobe_bpf__open_opts(NULL);
}

static inline int
bench_uprobe_bpf__load(struct bench_uprobe_bpf *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct bench_uprobe_bpf *
bench_uprobe_bpf__open_and_load(void)
{
	struct bench_uprobe_bpf *obj;
	int err;

	obj = bench_uprobe_bpf__open();
	if (!obj)
		return NULL;
	err = bench_uprobe_bpf__load(obj);
	if (err) {
		bench_uprobe_bpf__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
bench_uprobe_bpf__attach(struct bench_uprobe_bpf *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
bench_uprobe_bpf__detach(struct bench_uprobe_bpf *obj)
{
	bpf_object__detach_skeleton(obj->skeleton);
}

static inline const void *bench_uprobe_bpf__elf_bytes(size_t *sz);

static inline int
bench_uprobe_bpf__create_skeleton(struct bench_uprobe_bpf *obj)
{
	struct bpf_object_skeleton *s;
	int err;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)	{
		err = -ENOMEM;
		goto err;
	}

	s->sz = sizeof(*s);
	s->name = "bench_uprobe_bpf";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 2;
	s->map_skel_sz = sizeof(*s->maps);
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt, s->map_skel_sz);
	if (!s->maps) {
		err = -ENOMEM;
		goto err;
	}

	s->maps[0].name = "bench_up.bss";
	s->maps[0].map = &obj->maps.bss;
	s->maps[0].mmaped = (void **)&obj->bss;

	s->maps[1].name = ".rodata.str1.1";
	s->maps[1].map = &obj->maps.rodata_str1_1;

	/* programs */
	s->prog_cnt = 2;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs) {
		err = -ENOMEM;
		goto err;
	}

	s->progs[0].name = "empty";
	s->progs[0].prog = &obj->progs.empty;
	s->progs[0].link = &obj->links.empty;

	s->progs[1].name = "trace_printk";
	s->progs[1].prog = &obj->progs.trace_printk;
	s->progs[1].link = &obj->links.trace_printk;

	s->data = bench_uprobe_bpf__elf_bytes(&s->data_sz);

	obj->skeleton = s;
	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return err;
}

static inline const void *bench_uprobe_bpf__elf_bytes(size_t *sz)
{
	static const char data[] __attribute__((__aligned__(8))) = "\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\xc0\x0d\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x16\0\
\x01\0\xb7\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x61\x13\0\0\0\0\0\0\x07\x03\0\0\x01\0\0\0\x63\x31\0\0\0\0\0\0\xb7\x01\0\0\x65\
\x20\x25\x75\x63\x1a\xf8\xff\0\0\0\0\x18\x01\0\0\x63\x68\x20\x75\0\0\0\0\x70\
\x72\x6f\x62\x7b\x1a\xf0\xff\0\0\0\0\x18\x01\0\0\x70\x65\x72\x66\0\0\0\0\x20\
\x62\x65\x6e\x7b\x1a\xe8\xff\0\0\0\0\xb7\x01\0\0\0\0\0\0\x73\x1a\xfc\xff\0\0\0\
\0\xbf\xa1\0\0\0\0\0\0\x07\x01\0\0\xe8\xff\xff\xff\xb7\x02\0\0\x15\0\0\0\x85\0\
\0\0\x06\0\0\0\xb7\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\x44\x75\x61\x6c\x20\x42\x53\
\x44\x2f\x47\x50\x4c\0\0\0\0\x70\x65\x72\x66\x20\x62\x65\x6e\x63\x68\x20\x75\
\x70\x72\x6f\x62\x65\x20\x25\x75\0\x01\x11\x01\x25\x0e\x13\x05\x03\x0e\x10\x17\
\x1b\x0e\x11\x01\x12\x06\0\0\x02\x34\0\x03\x0e\x49\x13\x3f\x19\x3a\x0b\x3b\x0b\
\x02\x18\0\0\x03\x01\x01\x49\x13\0\0\x04\x21\0\x49\x13\x37\x0b\0\0\x05\x24\0\
\x03\x0e\x3e\x0b\x0b\x0b\0\0\x06\x24\0\x03\x0e\x0b\x0b\x3e\x0b\0\0\x07\x34\0\
\x03\x0e\x49\x13\x3a\x0b\x3b\x0b\0\0\x08\x0f\0\x49\x13\0\0\x09\x15\x01\x49\x13\
\x27\x19\0\0\x0a\x05\0\x49\x13\0\0\x0b\x18\0\0\0\x0c\x26\0\x49\x13\0\0\x0d\x16\
\0\x49\x13\x03\x0e\x3a\x0b\x3b\x0b\0\0\x0e\x2e\x01\x11\x01\x12\x06\x40\x18\x97\
\x42\x19\x03\x0e\x3a\x0b\x3b\x0b\x27\x19\x49\x13\x3f\x19\0\0\x0f\x05\0\x03\x0e\
\x3a\x0b\x3b\x0b\x49\x13\0\0\x10\x2e\x01\x03\x0e\x3a\x0b\x3b\x0b\x27\x19\x49\
\x13\x20\x0b\0\0\x11\x34\0\x03\x0e\x3a\x0b\x3b\x0b\x49\x13\0\0\x12\x13\0\x03\
\x0e\x3c\x19\0\0\x13\x1d\x01\x31\x13\x11\x01\x12\x06\x58\x0b\x59\x0b\x57\x0b\0\
\0\x14\x34\0\x02\x18\x31\x13\0\0\0\x56\x01\0\0\x04\0\0\0\0\0\x08\x01\0\0\0\0\
\x1d\0\x2c\0\0\0\0\0\0\0\x4d\0\0\0\0\0\0\0\0\0\0\0\xb8\0\0\0\x02\xc8\0\0\0\x3f\
\0\0\0\x01\x17\x09\x03\0\0\0\0\0\0\0\0\x03\x4b\0\0\0\x04\x52\0\0\0\x0d\0\x05\
\xd0\0\0\0\x06\x01\x06\xd5\0\0\0\x08\x07\x02\xe9\0\0\0\x6e\0\0\0\x01\x06\x09\
\x03\0\0\0\0\0\0\0\0\x05\xf4\0\0\0\x07\x04\x07\x01\x01\0\0\x80\0\0\0\x03\xb1\
\x08\x85\0\0\0\x09\x96\0\0\0\x0a\x9d\0\0\0\x0a\xa7\0\0\0\x0b\0\x05\x12\x01\0\0\
\x05\x08\x08\xa2\0\0\0\x0c\x4b\0\0\0\x0d\x6e\0\0\0\x17\x01\0\0\x02\x1b\x0e\0\0\
\0\0\0\0\0\0\x10\0\0\0\x01\x5a\x42\x01\0\0\x01\x09\xfa\0\0\0\x0f\x32\x01\0\0\
\x01\x09\x01\x01\0\0\0\x10\x1d\x01\0\0\x01\x0f\xfa\0\0\0\x01\x0f\x32\x01\0\0\
\x01\x0f\x01\x01\0\0\x11\x3e\x01\0\0\x01\x11\x0b\x01\0\0\0\x05\x2e\x01\0\0\x05\
\x04\x08\x06\x01\0\0\x12\x36\x01\0\0\x03\x4b\0\0\0\x04\x52\0\0\0\x15\0\x0e\x10\
\0\0\0\0\0\0\0\xa8\0\0\0\x01\x5a\x48\x01\0\0\x01\x0f\xfa\0\0\0\x0f\x32\x01\0\0\
\x01\x0f\x01\x01\0\0\x13\xd7\0\0\0\x10\0\0\0\0\0\0\0\x98\0\0\0\x01\x0f\x05\x14\
\x02\x91\0\xee\0\0\0\0\0\0\x63\x6c\x61\x6e\x67\x20\x76\x65\x72\x73\x69\x6f\x6e\
\x20\x31\x37\x2e\x30\x2e\x36\x20\x28\x46\x65\x64\x6f\x72\x61\x20\x31\x37\x2e\
\x30\x2e\x36\x2d\x36\x2e\x66\x63\x34\x30\x29\0\x75\x74\x69\x6c\x2f\x62\x70\x66\
\x5f\x73\x6b\x65\x6c\x2f\x62\x65\x6e\x63\x68\x5f\x75\x70\x72\x6f\x62\x65\x2e\
\x62\x70\x66\x2e\x63\0\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\
\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\x72\x6e\x65\x6c\x2d\x36\x2e\x38\x2d\
\x72\x63\x36\x2d\x33\x37\x2d\x67\x38\x30\x35\x64\x38\x34\x39\x64\x37\x63\x33\
\x63\x2f\x6c\x69\x6e\x75\x78\x2d\x36\x2e\x38\x2e\x30\x2d\x30\x2e\x72\x63\x36\
\x2e\x32\x30\x32\x34\x30\x32\x32\x39\x67\x69\x74\x38\x30\x35\x64\x38\x34\x39\
\x64\x37\x63\x33\x63\x2e\x35\x31\x2e\x66\x63\x34\x31\x2e\x61\x61\x72\x63\x68\
\x36\x34\x2f\x74\x6f\x6f\x6c\x73\x2f\x70\x65\x72\x66\0\x4c\x49\x43\x45\x4e\x53\
\x45\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\
\x54\x59\x50\x45\x5f\x5f\0\x6e\x72\x5f\x75\x70\x72\x6f\x62\x65\x73\0\x75\x6e\
\x73\x69\x67\x6e\x65\x64\x20\x69\x6e\x74\0\x62\x70\x66\x5f\x74\x72\x61\x63\x65\
\x5f\x70\x72\x69\x6e\x74\x6b\0\x6c\x6f\x6e\x67\0\x5f\x5f\x75\x33\x32\0\x5f\x5f\
\x5f\x5f\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\0\x69\x6e\x74\0\x63\
\x74\x78\0\x70\x74\x5f\x72\x65\x67\x73\0\x66\x6d\x74\0\x65\x6d\x70\x74\x79\0\
\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\0\x9f\xeb\x01\0\x18\0\0\0\0\0\
\0\0\0\x01\0\0\0\x01\0\0\x99\x01\0\0\0\0\0\0\0\0\0\x02\x02\0\0\0\x01\0\0\0\0\0\
\0\x07\0\0\0\0\0\0\0\0\x01\0\0\x0d\x04\0\0\0\x09\0\0\0\x01\0\0\0\x0d\0\0\0\0\0\
\0\x01\x04\0\0\0\x20\0\0\x01\x11\0\0\0\x01\0\0\x0c\x03\0\0\0\0\0\0\0\x01\0\0\
\x0d\x04\0\0\0\x09\0\0\0\x01\0\0\0\xd0\0\0\0\x01\0\0\x0c\x06\0\0\0\x53\x01\0\0\
\0\0\0\x01\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x08\0\0\0\x0a\0\0\0\
\x0d\0\0\0\x58\x01\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\x6c\x01\0\0\0\0\0\x0e\x09\
\0\0\0\x01\0\0\0\x74\x01\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\x81\x01\0\0\0\0\0\
\x0e\x0c\0\0\0\x01\0\0\0\x8c\x01\0\0\x01\0\0\x0f\0\0\0\0\x0d\0\0\0\0\0\0\0\x04\
\0\0\0\x91\x01\0\0\x01\0\0\x0f\0\0\0\0\x0b\0\0\0\0\0\0\0\x0d\0\0\0\0\x70\x74\
\x5f\x72\x65\x67\x73\0\x63\x74\x78\0\x69\x6e\x74\0\x65\x6d\x70\x74\x79\0\x75\
\x70\x72\x6f\x62\x65\0\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\
\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\x72\x6e\x65\x6c\x2d\x36\x2e\x38\x2d\
\x72\x63\x36\x2d\x33\x37\x2d\x67\x38\x30\x35\x64\x38\x34\x39\x64\x37\x63\x33\
\x63\x2f\x6c\x69\x6e\x75\x78\x2d\x36\x2e\x38\x2e\x30\x2d\x30\x2e\x72\x63\x36\
\x2e\x32\x30\x32\x34\x30\x32\x32\x39\x67\x69\x74\x38\x30\x35\x64\x38\x34\x39\
\x64\x37\x63\x33\x63\x2e\x35\x31\x2e\x66\x63\x34\x31\x2e\x61\x61\x72\x63\x68\
\x36\x34\x2f\x74\x6f\x6f\x6c\x73\x2f\x70\x65\x72\x66\x2f\x75\x74\x69\x6c\x2f\
\x62\x70\x66\x5f\x73\x6b\x65\x6c\x2f\x62\x65\x6e\x63\x68\x5f\x75\x70\x72\x6f\
\x62\x65\x2e\x62\x70\x66\x2e\x63\0\x69\x6e\x74\x20\x42\x50\x46\x5f\x55\x50\x52\
\x4f\x42\x45\x28\x65\x6d\x70\x74\x79\x29\0\x74\x72\x61\x63\x65\x5f\x70\x72\x69\
\x6e\x74\x6b\0\x09\x62\x70\x66\x5f\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\
\x6b\x28\x66\x6d\x74\x2c\x20\x73\x69\x7a\x65\x6f\x66\x28\x66\x6d\x74\x29\x2c\
\x20\x2b\x2b\x6e\x72\x5f\x75\x70\x72\x6f\x62\x65\x73\x29\x3b\0\x09\x63\x68\x61\
\x72\x20\x66\x6d\x74\x5b\x5d\x20\x3d\x20\x22\x70\x65\x72\x66\x20\x62\x65\x6e\
\x63\x68\x20\x75\x70\x72\x6f\x62\x65\x20\x25\x75\x22\x3b\0\x69\x6e\x74\x20\x42\
\x50\x46\x5f\x55\x50\x52\x4f\x42\x45\x28\x74\x72\x61\x63\x65\x5f\x70\x72\x69\
\x6e\x74\x6b\x29\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\
\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x4c\x49\x43\x45\x4e\x53\x45\0\x75\x6e\
\x73\x69\x67\x6e\x65\x64\x20\x69\x6e\x74\0\x6e\x72\x5f\x75\x70\x72\x6f\x62\x65\
\x73\0\x2e\x62\x73\x73\0\x6c\x69\x63\x65\x6e\x73\x65\0\0\0\0\x9f\xeb\x01\0\x20\
\0\0\0\0\0\0\0\x1c\0\0\0\x1c\0\0\0\x6c\0\0\0\x88\0\0\0\0\0\0\0\x08\0\0\0\x17\0\
\0\0\x02\0\0\0\0\0\0\0\x05\0\0\0\x10\0\0\0\x07\0\0\0\x10\0\0\0\x17\0\0\0\x06\0\
\0\0\0\0\0\0\x1e\0\0\0\xba\0\0\0\x05\x24\0\0\x10\0\0\0\x1e\0\0\0\xdd\0\0\0\x25\
\x4c\0\0\x40\0\0\0\x1e\0\0\0\x10\x01\0\0\x07\x44\0\0\x90\0\0\0\x1e\0\0\0\xdd\0\
\0\0\x25\x4c\0\0\x98\0\0\0\x1e\0\0\0\xdd\0\0\0\x02\x4c\0\0\xa8\0\0\0\x1e\0\0\0\
\x36\x01\0\0\x05\x3c\0\0\x0c\0\0\0\xff\xff\xff\xff\x04\0\x08\0\x08\x7c\x0b\0\
\x14\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x14\0\0\0\0\0\0\0\x10\0\0\
\0\0\0\0\0\xa8\0\0\0\0\0\0\0\xb3\0\0\0\x04\0\x85\0\0\0\x08\x01\x01\xfb\x0e\x0d\
\0\x01\x01\x01\x01\0\0\0\x01\0\0\x01\x75\x74\x69\x6c\x2f\x62\x70\x66\x5f\x73\
\x6b\x65\x6c\0\x2f\x75\x73\x72\x2f\x69\x6e\x63\x6c\x75\x64\x65\x2f\x61\x73\x6d\
\x2d\x67\x65\x6e\x65\x72\x69\x63\0\x2f\x75\x73\x72\x2f\x69\x6e\x63\x6c\x75\x64\
\x65\x2f\x62\x70\x66\0\0\x62\x65\x6e\x63\x68\x5f\x75\x70\x72\x6f\x62\x65\x2e\
\x62\x70\x66\x2e\x63\0\x01\0\0\x69\x6e\x74\x2d\x6c\x6c\x36\x34\x2e\x68\0\x02\0\
\0\x62\x70\x66\x5f\x68\x65\x6c\x70\x65\x72\x5f\x64\x65\x66\x73\x2e\x68\0\x03\0\
\0\0\x05\x05\x0a\0\x09\x02\0\0\0\0\0\0\0\0\x1a\x05\x25\x0a\x03\x0a\x2e\x05\x07\
\x64\x05\x25\xa0\x05\x02\x06\x20\x05\x05\x06\x2a\x02\x02\0\x01\x01\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xa2\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x03\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x0b\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x03\0\x12\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\x12\0\x03\0\0\0\0\0\0\0\
\0\0\x10\0\0\0\0\0\0\0\x53\0\0\0\x12\0\x03\0\x10\0\0\0\0\0\0\0\xa8\0\0\0\0\0\0\
\0\x2d\0\0\0\x11\0\x06\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\xce\0\0\0\x11\0\x05\
\0\0\0\0\0\0\0\0\0\x0d\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x01\0\0\0\x09\0\0\0\x06\
\0\0\0\0\0\0\0\x03\0\0\0\x03\0\0\0\x0c\0\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x12\0\
\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x16\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x1a\0\0\
\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x1e\0\0\0\0\0\0\0\x02\0\0\0\x02\0\0\0\x2b\0\0\0\
\0\0\0\0\x03\0\0\0\x04\0\0\0\x37\0\0\0\0\0\0\0\x02\0\0\0\x0a\0\0\0\x4c\0\0\0\0\
\0\0\0\x03\0\0\0\x04\0\0\0\x53\0\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x5a\0\0\0\0\0\
\0\0\x03\0\0\0\x04\0\0\0\x66\0\0\0\0\0\0\0\x02\0\0\0\x09\0\0\0\x6f\0\0\0\0\0\0\
\0\x03\0\0\0\x04\0\0\0\x76\0\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x97\0\0\0\0\0\0\0\
\x03\0\0\0\x04\0\0\0\xac\0\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\xb3\0\0\0\0\0\0\0\
\x02\0\0\0\x02\0\0\0\xc1\0\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\xcc\0\0\0\0\0\0\0\
\x03\0\0\0\x04\0\0\0\xd8\0\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\xe4\0\0\0\0\0\0\0\
\x03\0\0\0\x04\0\0\0\xef\0\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\xfb\0\0\0\0\0\0\0\
\x03\0\0\0\x04\0\0\0\x07\x01\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x18\x01\0\0\0\0\0\
\0\x02\0\0\0\x02\0\0\0\x26\x01\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x31\x01\0\0\0\0\
\0\0\x03\0\0\0\x04\0\0\0\x40\x01\0\0\0\0\0\0\x02\0\0\0\x02\0\0\0\xf8\0\0\0\0\0\
\0\0\x04\0\0\0\x09\0\0\0\x10\x01\0\0\0\0\0\0\x04\0\0\0\x0a\0\0\0\x2c\0\0\0\0\0\
\0\0\x04\0\0\0\x02\0\0\0\x34\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x48\0\0\0\0\0\0\
\0\x04\0\0\0\x02\0\0\0\x58\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x68\0\0\0\0\0\0\0\
\x04\0\0\0\x02\0\0\0\x78\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x88\0\0\0\0\0\0\0\
\x04\0\0\0\x02\0\0\0\x98\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x14\0\0\0\0\0\0\0\
\x03\0\0\0\x05\0\0\0\x18\0\0\0\0\0\0\0\x02\0\0\0\x02\0\0\0\x2c\0\0\0\0\0\0\0\
\x03\0\0\0\x05\0\0\0\x30\0\0\0\0\0\0\0\x02\0\0\0\x02\0\0\0\x95\0\0\0\0\0\0\0\
\x02\0\0\0\x02\0\0\0\x07\x08\x0a\0\x65\x6d\x70\x74\x79\0\x2e\x64\x65\x62\x75\
\x67\x5f\x61\x62\x62\x72\x65\x76\0\x2e\x74\x65\x78\x74\0\x2e\x72\x65\x6c\x2e\
\x42\x54\x46\x2e\x65\x78\x74\0\x2e\x62\x73\x73\0\x6e\x72\x5f\x75\x70\x72\x6f\
\x62\x65\x73\0\x2e\x64\x65\x62\x75\x67\x5f\x73\x74\x72\0\x2e\x72\x65\x6c\x2e\
\x64\x65\x62\x75\x67\x5f\x69\x6e\x66\x6f\0\x74\x72\x61\x63\x65\x5f\x70\x72\x69\
\x6e\x74\x6b\0\x2e\x6c\x6c\x76\x6d\x5f\x61\x64\x64\x72\x73\x69\x67\0\x6c\x69\
\x63\x65\x6e\x73\x65\0\x2e\x72\x65\x6c\x2e\x64\x65\x62\x75\x67\x5f\x6c\x69\x6e\
\x65\0\x2e\x72\x65\x6c\x2e\x64\x65\x62\x75\x67\x5f\x66\x72\x61\x6d\x65\0\x2e\
\x72\x65\x6c\x75\x70\x72\x6f\x62\x65\0\x62\x65\x6e\x63\x68\x5f\x75\x70\x72\x6f\
\x62\x65\x2e\x62\x70\x66\x2e\x63\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\
\x6d\x74\x61\x62\0\x2e\x72\x65\x6c\x2e\x42\x54\x46\0\x4c\x49\x43\x45\x4e\x53\
\x45\0\x2e\x72\x6f\x64\x61\x74\x61\x2e\x73\x74\x72\x31\x2e\x31\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xb5\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\xdb\x0c\0\0\0\0\0\0\xe5\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x15\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x9b\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\xb8\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x97\0\0\0\x09\
\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x0a\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\
\x15\0\0\0\x03\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x6e\0\0\0\x01\0\0\0\
\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xf8\0\0\0\0\0\0\0\x0d\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x28\0\0\0\x08\0\0\0\x03\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\x08\x01\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xd6\0\0\0\x01\0\0\0\x32\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x08\x01\0\0\0\0\0\0\x15\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\
\x01\0\0\0\0\0\0\0\x07\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x1d\x01\
\0\0\0\0\0\0\xf0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x47\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x0d\x02\0\0\0\0\0\0\x5a\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x43\0\0\0\
\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x28\x0a\0\0\0\0\0\0\xc0\x01\0\0\0\
\0\0\0\x15\0\0\0\x09\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x38\0\0\0\x01\0\
\0\0\x30\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x67\x03\0\0\0\0\0\0\x55\x01\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\xc9\0\0\0\x01\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\xbc\x04\0\0\0\0\0\0\xb1\x02\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xc5\0\0\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\xe8\x0b\0\0\0\0\0\0\x20\0\0\0\0\0\0\0\x15\0\0\0\x0c\0\0\0\x08\0\
\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x1f\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x70\x07\0\0\0\0\0\0\xa8\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x1b\0\0\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\x0c\0\
\0\0\0\0\0\x80\0\0\0\0\0\0\0\x15\0\0\0\x0e\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\
\0\0\0\x8a\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x08\0\0\0\0\0\0\
\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x86\0\0\0\
\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x88\x0c\0\0\0\0\0\0\x40\0\0\0\0\0\
\0\0\x15\0\0\0\x10\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x7a\0\0\0\x01\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x58\x08\0\0\0\0\0\0\xb7\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x76\0\0\0\x09\0\0\0\x40\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\xc8\x0c\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x15\0\0\0\x12\0\0\0\
\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x60\0\0\0\x03\x4c\xff\x6f\0\0\0\x80\0\0\0\
\0\0\0\0\0\0\0\0\0\xd8\x0c\0\0\0\0\0\0\x03\0\0\0\0\0\0\0\x15\0\0\0\0\0\0\0\x01\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xbd\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x10\x09\0\0\0\0\0\0\x08\x01\0\0\0\0\0\0\x01\0\0\0\x07\0\0\0\x08\0\0\0\0\0\
\0\0\x18\0\0\0\0\0\0\0";

	*sz = sizeof(data) - 1;
	return (const void *)data;
}

#ifdef __cplusplus
struct bench_uprobe_bpf *bench_uprobe_bpf::open(const struct bpf_object_open_opts *opts) { return bench_uprobe_bpf__open_opts(opts); }
struct bench_uprobe_bpf *bench_uprobe_bpf::open_and_load() { return bench_uprobe_bpf__open_and_load(); }
int bench_uprobe_bpf::load(struct bench_uprobe_bpf *skel) { return bench_uprobe_bpf__load(skel); }
int bench_uprobe_bpf::attach(struct bench_uprobe_bpf *skel) { return bench_uprobe_bpf__attach(skel); }
void bench_uprobe_bpf::detach(struct bench_uprobe_bpf *skel) { bench_uprobe_bpf__detach(skel); }
void bench_uprobe_bpf::destroy(struct bench_uprobe_bpf *skel) { bench_uprobe_bpf__destroy(skel); }
const void *bench_uprobe_bpf::elf_bytes(size_t *sz) { return bench_uprobe_bpf__elf_bytes(sz); }
#endif /* __cplusplus */

__attribute__((unused)) static void
bench_uprobe_bpf__assert(struct bench_uprobe_bpf *s __attribute__((unused)))
{
#ifdef __cplusplus
#define _Static_assert static_assert
#endif
	_Static_assert(sizeof(s->bss->nr_uprobes) == 4, "unexpected size of 'nr_uprobes'");
#ifdef __cplusplus
#undef _Static_assert
#endif
}

#endif /* __BENCH_UPROBE_BPF_SKEL_H__ */
